<template>
  <div class="w-full flex flex-col items-center gap-2">
    <svn-pro-title
      v-if="progress === SvnProGraphTargetProgress.notSet"
      h5
      medium
      color="onSurfaceVariant"
      class="max-w-[304px] line-clamp-1 break-all"
    >
      {{ notSetText }}
    </svn-pro-title>

    <svn-pro-title
      v-else
      h5
      medium
      :color="getColor()"
      class="max-w-[304px] line-clamp-1 break-all"
    >
      {{
        indicatorType === SvnProGraphTargetIndicatorType.string
          ? currentValue
          : `${currentValue}/${targetValue}`
      }}
    </svn-pro-title>

    <div class="w-[240px]">
      <svn-pro-progress-linear
        :color="getColor()"
        bg-color="surfaceLight"
        :model-value="calculateModelValue()"
      />
    </div>
  </div>
</template>

<script>
import SvnProTitle from '../styles/SvnProTitle.vue';
import SvnProProgressLinear from '../progress/SvnProProgressLinear.vue';

export const SvnProGraphTargetProgress = Object.freeze({
  notSet: 'not_set',
  notStarted: 'not_started',
  inProgress: 'in_progress',
  achieved: 'achieved',
});

export const SvnProGraphTargetIndicatorType = Object.freeze({
  numeric: 'numeric',
  string: 'string',
});

export default {
  name: 'SvnProGraphTarget',
  props: {
    progress: {
      type: String,
      required: true,
      default: SvnProGraphTargetProgress.notSet,
      validator(value, props) {
        return Object.values(SvnProGraphTargetProgress).includes(value);
      },
    },
    indicatorType: {
      type: String,
      required: true,
      default: SvnProGraphTargetIndicatorType.numeric,
      validator(value, props) {
        return Object.values(SvnProGraphTargetIndicatorType).includes(value);
      },
    },
    currentValue: {
      type: String,
      default: undefined,
    },
    targetValue: {
      type: String,
      default: undefined,
    },
    notSetText: {
      type: String,
      default: 'Not set yet',
    },
  },
  methods: {
    getColor() {
      switch (this.progress) {
        case 'not_set':
          return 'onSurfaceVariant';
        case 'not_started':
          return 'error';
        case 'in_progress':
          return 'warning';
        case 'achieved':
          return 'success';
        default:
          return 'onSurfaceVariant';
      }
    },
    calculateModelValue() {
      switch (this.progress) {
        case 'not_set':
          return 0;
        case 'not_started':
          return 0;
        case 'in_progress':
          if (
            this.indicatorType === this.SvnProGraphTargetIndicatorType.numeric
          ) {
            return (
              (parseInt(this.currentValue) / parseInt(this.targetValue)) * 100
            );
          } else {
            return 50;
          }
        case 'achieved':
          return 100;
        default:
          return 0;
      }
    },
  },
  computed: {
    SvnProGraphTargetIndicatorType() {
      return SvnProGraphTargetIndicatorType;
    },
    SvnProGraphTargetProgress() {
      return SvnProGraphTargetProgress;
    },
  },
  components: {
    SvnProTitle,
    SvnProProgressLinear,
  },
};
</script>
